import javax.swing.JDialog;
import javax.swing.JFrame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import java.lang.reflect.Array;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import java.awt.BorderLayout;
/**
 * Die Klasse AusgabeHaeufigkeiten dient der Ausgabe der berechneten Hufigkeiten.
 * 
 * @author (claus albowski) 
 * @version (03'06)
 */
public class AusgabeHaeufigkeiten
extends JDialog
{
    private JLabel labelHaeufigkeiten;
    private JButton endeButton;
    private JTable tabelle;
    private JScrollPane scroll;
    private AbstractTableModel dasModell;
    private int[] haeufigkeiten;

    /**
     * Konstruktor fr Objekte der Klasse AusgabeHaeufigkeiten
     */
    public AusgabeHaeufigkeiten(JFrame owner, String title, boolean modal, int[] haeufigkeiten)
    {
        super(owner, title, modal);
        this.haeufigkeiten=haeufigkeiten;
        setLayout(new BorderLayout());

        labelHaeufigkeiten = new JLabel("Hufigkeiten");
        add(labelHaeufigkeiten, BorderLayout.NORTH);

        endeButton = new JButton ("ENDE");
        add(endeButton, BorderLayout.SOUTH);
        

        // Tabelle
        dasModell = new ModellKlasse();
        setzeTabellenDaten();
        tabelle = new JTable(dasModell);
        scroll = new JScrollPane(tabelle);
        add(scroll, BorderLayout.CENTER);
        
        pack();
        setVisible(true);
        
        endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });

        addWindowListener(new WindowAdapter() { // reagiert auf Fenster schliessen
            public void windowClosing(WindowEvent evt) {
                dispose();
            }
        });
    }
    
    /**
     * interne Klasse fr das Datenmodell.
     */
    private class ModellKlasse extends AbstractTableModel {
        private String[] spaltenBeschriftungen = { "Buchstabe", "Hufigkeit" };
        private Object[][] daten = new String[26][2];
        
        public int getRowCount() { return daten.length; }
        public int getColumnCount() { return spaltenBeschriftungen.length; }
        public boolean isCellEditable(int row, int col) { return false; }
        public Object getValueAt(int row, int col) { return daten[row][col]; }
        public void setValueAt(Object value, int row, int col) {
            daten[row][col] = value;
            fireTableCellUpdated(row, col);
        }
    }
    
    /**
     * Methode zum Setzen der Tabellendaten
     */
    private void setzeTabellenDaten() {
        for (int i=0; i<26; i++) {
            dasModell.setValueAt(((char) (i+65))+"\r\n",i,0);
            dasModell.setValueAt(haeufigkeiten[i]+"\r\n",i,1);
        }
    }
    

}
