import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  *
  * Beschreibung.
  *
  * @version 1.0 vom 28.01.2006
  * @author
  */

public class Gui extends JFrame {
  // Anfang Variablen
  
    private JLabel labelEingabe, labelSchluessel, labelAusgabe;
    private JTextField editSchluessel;
    private JButton codiereButton, decodiereButton, endeButton;
    private JTextArea ausgabe; 
    private TextInterface text;
    private static VigenereInterface vigenere;
  
  // Ende Variablen

  /**
   * Konstruktor
   */
  public Gui(String title, int breite, int hoehe) {
    // Frame-Initialisierung
    super(title);
    text=new Text();
    setJMenuBar(machMenueLeiste());
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { beendenAction(); }
    });
    // Attribute
    setSize(breite, hoehe);
    setLocation(20, 20);
    Container contentPane = getContentPane();
    contentPane.setLayout(null);
    // Anfang Komponenten
        labelEingabe = new JLabel("Eingabe");
        labelEingabe.setBounds(10, 10, 100, 20);
        contentPane.add(labelEingabe);

        labelSchluessel = new JLabel("Schluessel");
        labelSchluessel.setBounds(10, 80, 100, 20);
        contentPane.add(labelSchluessel);
        
        labelAusgabe = new JLabel("Ausgabe");
        labelAusgabe.setBounds(170, 10, 100, 20);
        contentPane.add(labelAusgabe);

        // Textfelder
        editSchluessel = new JTextField("a");
        editSchluessel.setBounds(10, 110, 100, 20);
        contentPane.add(editSchluessel);
        
        // Buttons
        codiereButton = new JButton ("codiere");
        codiereButton.setBounds(10, 40, 100, 20);
        contentPane.add(codiereButton);
        
        decodiereButton = new JButton ("decodiere");
        decodiereButton.setBounds(10, 160, 100, 20);
        contentPane.add(decodiereButton);
        
        endeButton = new JButton ("ENDE");
        endeButton.setBounds(10, 200, 100, 20);
        contentPane.add(endeButton);
        
        // Textarea
        ausgabe = new JTextArea();
        ausgabe.setText(null);
        JScrollPane scroll = new JScrollPane(ausgabe);
        scroll.setBounds(160, 40, 200, 200);
        contentPane.add(scroll);
        

    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  // Anfang Ereignisprozeduren
    endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
        public void actionPerformed(ActionEvent e) { beendenAction(); }
    });
    codiereButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) { codierenAction(); }
    });
    decodiereButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) { deCodierenAction(); }
    });

  // Ende Ereignisprozeduren

  }
    /**
     * Definition der Menleiste
     */
    private JMenuBar machMenueLeiste() {
        // enthaltene Objekte definieren
        JMenuBar menueLeiste = new JMenuBar();

        JMenu menueDatei = new JMenu("Datei");
        JMenuItem menueEintragOeffnen = new JMenuItem("ffnen");
        JMenuItem menueEintragSpeichern = new JMenuItem("Speichern");
        JMenuItem menueEintragEnde = new JMenuItem("Ende");

        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        JMenuItem menueEintragCodiere = new JMenuItem("Codiere");
        JMenuItem menueEintragDecodieren = new JMenuItem("Decodiere");
        JMenuItem menueEintragHaeufigkeiten = new JMenuItem("Hufigkeiten");

        // Listener definieren
        menueEintragOeffnen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { OeffnenAction(); }
        });
        menueEintragSpeichern.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { SpeichernAction(); }
        });
        menueEintragEnde.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e)  { beendenAction(); }
        });
        menueEintragCodiere.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { codierenAction(); }
        });
        menueEintragDecodieren.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { deCodierenAction(); }
        });
        menueEintragHaeufigkeiten.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { haeufigkeitenAction(); }
        });


        // hinzufgen
        menueDatei.add(menueEintragOeffnen);
        menueDatei.add(menueEintragSpeichern);
        menueDatei.add(menueEintragEnde);

        menueBearbeiten.add(menueEintragCodiere);
        menueBearbeiten.add(menueEintragDecodieren);
        menueBearbeiten.add(menueEintragHaeufigkeiten);

        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);

        return menueLeiste;
    }
    
    
    // Actions
    private void OeffnenAction(){
        JFileChooser fc = new JFileChooser("E:\\JAVA\\JAVA-Kryptologie\\CaesarDateiDialog");
        int returnVal = fc.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            text.waehleDateiNamen(fc.getCurrentDirectory()+"\\"+fc.getSelectedFile().getName());
        } 
        if (JOptionPane.showConfirmDialog(
        this, "Text ersetzen?", "besttigen !" , JOptionPane.OK_CANCEL_OPTION)==JOptionPane.OK_OPTION){
            text.dateiLesen();
            ausgabe.setText(text.gibText());
        }
    }
    
    private void SpeichernAction(){
        JFileChooser fc = new JFileChooser("E:\\JAVA\\JAVA-Kryptologie\\CaesarDateiDialog");
        int returnVal = fc.showSaveDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            text.waehleDateiNamen(fc.getCurrentDirectory()+"\\"+fc.getSelectedFile().getName());
        }
        if (JOptionPane.showConfirmDialog(
            this, "Text ersetzen?", "besttigen !" , JOptionPane.OK_CANCEL_OPTION)==JOptionPane.OK_OPTION){
            text.neuerText(ausgabe.getText());
            text.dateiSchreiben();
        }
    }
    
    private void beendenAction(){ 
        if (JOptionPane.showConfirmDialog(this, "wirklich beenden?", "prfen !" , JOptionPane.OK_CANCEL_OPTION)==JOptionPane.OK_OPTION)
        System.exit(0);
    }
    
    private void keySetzen(){
        String key = editSchluessel.getText();
        StringBuffer temp=new StringBuffer();
        for (int i=0;i<key.length();i++)
        if (vigenere.istGrossBuchstabe(Character.toUpperCase(key.charAt(i))))
        temp.append(Character.toUpperCase(key.charAt(i)));
        if (temp.toString().equals("")) editSchluessel.setText("Buchstaben!");
        else vigenere.setzeSchluessel(temp.toString());
    }
    
    
    private void codierenAction(){
        keySetzen();
        vigenere.setzeOriginalText(ausgabe.getText());
        vigenere.verschluessele();
        labelAusgabe.setText("codiert:");
        ausgabe.setText(vigenere.zeigeText());
    }
    
    private void deCodierenAction(){
        keySetzen();
        vigenere.setzeCodetext(ausgabe.getText());
        vigenere.entschluessele();
        labelAusgabe.setText("DECODIERT:");
        ausgabe.setText(vigenere.zeigeText());
    }
    
    private void haeufigkeitenAction(){
        int[] haeufigkeiten = vigenere.haeufigkeiten(); 
        new AusgabeHaeufigkeiten(this, "Hufigkeiten", false, haeufigkeiten);
    }


  public static void main(String[] args) {
    vigenere = new Vigenere();
    new Gui("Gui", 400, 300);
  }
}

