
/**
 * Klasse Vigenere.
 * 
 * @author (claus albowski) 
 * @version (Jan'06)
 */
public class Vigenere 
implements VigenereInterface
{
    // Instanzvariable
    String original, code;
    String key;
    int keyLength;
    boolean originalTextEingegeben, codeTextEingegeben, 
            schluesselEingegeben, istCodiert, istDecodiert;


    /**
     * Konstruktor fr Objekte der Klasse Caesar
     */
    public Vigenere()
    {
        // Instanzvariable initialisieren
        original=code=null; 
        key = "A";
        keyLength=1;
        originalTextEingegeben=codeTextEingegeben=schluesselEingegeben
                  =istCodiert=istDecodiert=false;
    }
    // ffentliche Methoden:
    
    
    /**
     * gibt jeweils den bearbeiteten Text aus.
     */
    public String zeigeText(){
        if (istDecodiert) return original;
        else if (istCodiert) return code;
        else return "Keine Bearbeitung!";
    }
    
    /**
     * setzt den Originaltext
     */
    public void setzeOriginalText(String text){
        original=text;
        code = null;
        originalTextEingegeben=true;
        istCodiert=istDecodiert=false;
    }

    /**
     * setzt den Codetext
     */
    public void setzeCodetext(String text){
        code=text;
        original =  null;
        codeTextEingegeben=true;
        istCodiert=istDecodiert=false;
    }

    /**
     * setzt den Schluessel
     */
    public void setzeSchluessel(String schluessel){
        key=schluessel;
        keyLength=key.length();
        schluesselEingegeben=true;
    }

    /**
     * verschluesselt den eingegebenen Text
     */
    public void verschluessele(){
        if (originalTextEingegeben){
            code = verschluessele(original, false);
            istCodiert=true;
        }
    }

    /**
     * entschluesselt den eingegebenen Text
     */
    public void entschluessele(){
        if (codeTextEingegeben){
            original = verschluessele(code, true);
            istDecodiert=true;
        }
    }
    
    /**
     * prft, ob ein Zeichen Grobuchstabe ist.
     */
    public boolean istGrossBuchstabe(Character c){
        return !((c.compareTo('A')<0)||(c.compareTo('Z')>0));
        // interessanterweise wird  zu ss vorher! konvertiert!
    }
    /**
     * erstellt eine Hufigkeitsanalyse der Buchstaben des Codes.
     * gibt die Ergebnisse in einem Array zurck.
     */  
    public int[] haeufigkeiten(){
        int[] haeufigkeiten= new int[26];
        Character c;
        if (code!=null){
            for (int i=0; i<code.length();i++){
                c=code.charAt(i);
                if (istGrossBuchstabe(c)) haeufigkeiten[Character.getNumericValue(c)-10]++;
            }
        }
        return haeufigkeiten;
    }
    
    
    // private Methoden:
    
    /**
     * fhrt das verschlsseln aus
     */
    private String verschluessele(String text, boolean sollDecodieren){
        text = entferneSonderzeichen(text.toUpperCase());
        StringBuffer temp = new StringBuffer();
        for (int i=0; i<text.length(); i++){
            int buchstabe = text.charAt(i);
            int schluessel = key.charAt(i % keyLength);
            if (sollDecodieren)schluessel=-schluessel;
            buchstabe = ((buchstabe+schluessel+26) % 26)+65;
            temp.append((char) buchstabe);
        }
        return temp.toString();
    }
    
    /**
     * entfernt die Sonderzeichen aus dem Text.
     */
    private String entferneSonderzeichen(String text){
        StringBuffer temp = new StringBuffer();
        for (int i=0; i<text.length();i++)
        if (istGrossBuchstabe(text.charAt(i)))
        temp.append(text.charAt(i));
        return new String(temp);
    }
    
}

