
/**
 * Beschreibung des Interface VigenereInterface ein.
 * Vor einer bersetzung (verschlssele oder entschlssele) mssen 
 * ---entweder Schlssel und Originaltext eingegeben worden sein
 * ---oder Schlssel und Codetext eingegeben worden sein
 * 
 * @author (claus albowski) 
 * @version (April'06)
 */

public interface VigenereInterface
{
    // gibt jeweils den bearbeiteten Text aus.
    public String zeigeText();
    
    // setzt den Originaltext
    public void setzeOriginalText(String text);

    // setzt den Codetext
    public void setzeCodetext(String text);

    // setzt den Schluessel
    public void setzeSchluessel(String schluessel);

    // verschluesselt den eingegebenen Text
    public void verschluessele();

    // entschluesselt den eingegebenen Text
    public void entschluessele();    

    // prft, ob ein Zeichen Grobuchstabe ist.
    public boolean istGrossBuchstabe(Character c);    
    
    // erstellt eine Hufigkeitsanalyse der Buchstaben und gibt die Ergebnisse in einem Array zurck.
    public int[] haeufigkeiten();
}
